/**
 * 
 */
package com.onegini.oidc.config;

import java.security.KeyManagementException;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;

import javax.net.ssl.SSLContext;

import org.apache.http.conn.ssl.SSLConnectionSocketFactory;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.ssl.TrustStrategy;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.client.HttpComponentsClientHttpRequestFactory;
import org.springframework.web.client.RestTemplate;

/**
 * 描述: 访问k8s的https请求的restTemplate的配置
 * restTemplate访问ssl：https://segmentfault.com/a/1190000010754013
 * restTemplate设置用户名和密码访问：http://blog.csdn.net/xiaoyaoyulinger/article/details/62235446
 * @version: 0_1
 * @author: 谷春
 * @date: 2018-01-19 11:39:09
 */
@Configuration
public class RestTemplateSSLConfig {
    
    @Bean
    public RestTemplate restTemplateSSL() throws KeyStoreException, NoSuchAlgorithmException, KeyManagementException {
        TrustStrategy acceptingTrustStrategy = (chain, authType) -> true;

        SSLContext sslContext = org.apache.http.ssl.SSLContexts.custom()
                .loadTrustMaterial(null, acceptingTrustStrategy)
                .build();

        SSLConnectionSocketFactory csf = new SSLConnectionSocketFactory(sslContext);
        CloseableHttpClient httpClient = HttpClients.custom()
//                .setDefaultCredentialsProvider(provider())
                .setSSLSocketFactory(csf)
                .build();

        HttpComponentsClientHttpRequestFactory requestFactory =
                new HttpComponentsClientHttpRequestFactory();

        requestFactory.setHttpClient(httpClient);

        //创建返回对象
        RestTemplate restTemplate = new RestTemplate(requestFactory);
        return restTemplate;
    }
    
//    private CredentialsProvider provider() {
//        CredentialsProvider provider = new BasicCredentialsProvider();
//        UsernamePasswordCredentials credentials = new UsernamePasswordCredentials(kubernetesConfig.getUserName(), kubernetesConfig.getPassword());
//        provider.setCredentials(AuthScope.ANY, credentials);  
//        return provider;  
//    }  
}
